import{s as Tt,f as tt,n as bt,o as At}from"../chunks/scheduler.f6b352c8.js";import{S as Pt,i as Ct,g as o,s,r as wt,A as $t,h as a,f as n,c as l,j as _t,u as Mt,x as r,k as u,y as kt,a as i,v as yt,d as xt,t as Lt,w as Ht}from"../chunks/index.7f38e934.js";import{H as Ut}from"../chunks/Heading.333929c4.js";import{E as qt}from"../chunks/EditOnGithub.c3245a01.js";function Et(et){let m,k,C,U,p,q,g,nt,E,c,it="Welcome to this first unit, where <strong>you’ll build a solid foundation in the fundamentals of AI Agents</strong> including:",I,f,st="<li><p><strong>Understanding Agents</strong></p> <ul><li>What is an Agent, and how does it work?</li> <li>How do Agents make decisions using reasoning and planning?</li></ul></li> <li><p><strong>The Role of LLMs (Large Language Models) in Agents</strong></p> <ul><li>How LLMs serve as the “brain” behind an Agent.</li> <li>How LLMs structure conversations via the Messages system.</li></ul></li> <li><p><strong>Tools and Actions</strong></p> <ul><li>How Agents use external tools to interact with the environment.</li> <li>How to build and integrate tools for your Agent.</li></ul></li> <li><p><strong>The Agent Workflow:</strong></p> <ul><li><em>Think</em> → <em>Act</em> → <em>Observe</em>.</li></ul></li>",G,d,lt="After exploring these topics, <strong>you’ll build your first Agent</strong> using <code>smolagents</code>!",j,h,ot="Your Agent, named Alfred, will handle a simple task and demonstrate how to apply these concepts in practice.",F,v,at="You’ll even learn how to <strong>publish your Agent on Hugging Face Spaces</strong>, so you can share it with friends and colleagues.",W,w,rt="Finally, at the end of this Unit, you’ll take a quiz. Pass it, and you’ll <strong>earn your first course certification</strong>: the 🎓 Certificate of Fundamentals of Agents.",z,_,ut,R,M,mt="This Unit is your <strong>essential starting point</strong>, laying the groundwork for understanding Agents before you move on to more advanced topics.",S,y,pt,Q,x,gt="It’s a big Unit, so do <strong>take your time</strong> and don’t hesitate to come back to these sections from time to time.",O,Y,D,L,ct="We’ll have a <strong>live Q&amp;A this Wednesday, February 12th at 5PM CET</strong>, where we <strong>will explain how the course works</strong> (scope, units, challenges and more), and we’ll be happy to <strong>answer your questions</strong>.",N,H,ft='👉 <a href="https://www.youtube.com/live/PopqUt3MGyQ?feature=shared" rel="nofollow">https://www.youtube.com/live/PopqUt3MGyQ?feature=shared</a>',B,T,dt="👉 Don’t forget <strong>to click “Notify me”</strong> so you don’t miss it!",J,b,ht,K,A,vt="Ready? Let’s dive in! 🚀",V,P,X,$,Z;return p=new Ut({props:{title:"Introduction to Agents",local:"introduction-to-agents",headingTag:"h1"}}),P=new qt({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/en/unit1/introduction.mdx"}}),{c(){m=o("meta"),k=s(),C=o("p"),U=s(),wt(p.$$.fragment),q=s(),g=o("img"),E=s(),c=o("p"),c.innerHTML=it,I=s(),f=o("ul"),f.innerHTML=st,G=s(),d=o("p"),d.innerHTML=lt,j=s(),h=o("p"),h.textContent=ot,F=s(),v=o("p"),v.innerHTML=at,W=s(),w=o("p"),w.innerHTML=rt,z=s(),_=o("img"),R=s(),M=o("p"),M.innerHTML=mt,S=s(),y=o("img"),Q=s(),x=o("p"),x.innerHTML=gt,O=s(),Y=o("hr"),D=s(),L=o("p"),L.innerHTML=ct,N=s(),H=o("p"),H.innerHTML=ft,B=s(),T=o("p"),T.innerHTML=dt,J=s(),b=o("img"),K=s(),A=o("p"),A.textContent=vt,V=s(),wt(P.$$.fragment),X=s(),$=o("p"),this.h()},l(t){const e=$t("svelte-u9bgzb",document.head);m=a(e,"META",{name:!0,content:!0}),e.forEach(n),k=l(t),C=a(t,"P",{}),_t(C).forEach(n),U=l(t),Mt(p.$$.fragment,t),q=l(t),g=a(t,"IMG",{src:!0,alt:!0}),E=l(t),c=a(t,"P",{"data-svelte-h":!0}),r(c)!=="svelte-wkib5g"&&(c.innerHTML=it),I=l(t),f=a(t,"UL",{"data-svelte-h":!0}),r(f)!=="svelte-1azxix2"&&(f.innerHTML=st),G=l(t),d=a(t,"P",{"data-svelte-h":!0}),r(d)!=="svelte-1p0xvef"&&(d.innerHTML=lt),j=l(t),h=a(t,"P",{"data-svelte-h":!0}),r(h)!=="svelte-ezryxl"&&(h.textContent=ot),F=l(t),v=a(t,"P",{"data-svelte-h":!0}),r(v)!=="svelte-lvpe36"&&(v.innerHTML=at),W=l(t),w=a(t,"P",{"data-svelte-h":!0}),r(w)!=="svelte-gq35aj"&&(w.innerHTML=rt),z=l(t),_=a(t,"IMG",{src:!0,alt:!0}),R=l(t),M=a(t,"P",{"data-svelte-h":!0}),r(M)!=="svelte-qlnt3o"&&(M.innerHTML=mt),S=l(t),y=a(t,"IMG",{src:!0,alt:!0}),Q=l(t),x=a(t,"P",{"data-svelte-h":!0}),r(x)!=="svelte-d77844"&&(x.innerHTML=gt),O=l(t),Y=a(t,"HR",{}),D=l(t),L=a(t,"P",{"data-svelte-h":!0}),r(L)!=="svelte-rwvsr5"&&(L.innerHTML=ct),N=l(t),H=a(t,"P",{"data-svelte-h":!0}),r(H)!=="svelte-w9aved"&&(H.innerHTML=ft),B=l(t),T=a(t,"P",{"data-svelte-h":!0}),r(T)!=="svelte-170842"&&(T.innerHTML=dt),J=l(t),b=a(t,"IMG",{src:!0,alt:!0}),K=l(t),A=a(t,"P",{"data-svelte-h":!0}),r(A)!=="svelte-1edxyhw"&&(A.textContent=vt),V=l(t),Mt(P.$$.fragment,t),X=l(t),$=a(t,"P",{}),_t($).forEach(n),this.h()},h(){u(m,"name","hf:doc:metadata"),u(m,"content",It),tt(g.src,nt="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/thumbnail.jpg")||u(g,"src",nt),u(g,"alt","Thumbnail"),tt(_.src,ut="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/certificate-example.jpg")||u(_,"src",ut),u(_,"alt","Certificate Example"),tt(y.src,pt="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/whiteboard-no-check.jpg")||u(y,"src",pt),u(y,"alt","Unit 1 planning"),tt(b.src,ht="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/communication/live1.jpg")||u(b,"src",ht),u(b,"alt","First live thumbnail")},m(t,e){kt(document.head,m),i(t,k,e),i(t,C,e),i(t,U,e),yt(p,t,e),i(t,q,e),i(t,g,e),i(t,E,e),i(t,c,e),i(t,I,e),i(t,f,e),i(t,G,e),i(t,d,e),i(t,j,e),i(t,h,e),i(t,F,e),i(t,v,e),i(t,W,e),i(t,w,e),i(t,z,e),i(t,_,e),i(t,R,e),i(t,M,e),i(t,S,e),i(t,y,e),i(t,Q,e),i(t,x,e),i(t,O,e),i(t,Y,e),i(t,D,e),i(t,L,e),i(t,N,e),i(t,H,e),i(t,B,e),i(t,T,e),i(t,J,e),i(t,b,e),i(t,K,e),i(t,A,e),i(t,V,e),yt(P,t,e),i(t,X,e),i(t,$,e),Z=!0},p:bt,i(t){Z||(xt(p.$$.fragment,t),xt(P.$$.fragment,t),Z=!0)},o(t){Lt(p.$$.fragment,t),Lt(P.$$.fragment,t),Z=!1},d(t){t&&(n(k),n(C),n(U),n(q),n(g),n(E),n(c),n(I),n(f),n(G),n(d),n(j),n(h),n(F),n(v),n(W),n(w),n(z),n(_),n(R),n(M),n(S),n(y),n(Q),n(x),n(O),n(Y),n(D),n(L),n(N),n(H),n(B),n(T),n(J),n(b),n(K),n(A),n(V),n(X),n($)),n(m),Ht(p,t),Ht(P,t)}}}const It='{"title":"Introduction to Agents","local":"introduction-to-agents","sections":[],"depth":1}';function Gt(et){return At(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Rt extends Pt{constructor(m){super(),Ct(this,m,Gt,Et,Tt,{})}}export{Rt as component};
