import{s as Pe,o as He,n as Re}from"../chunks/scheduler.f6b352c8.js";import{S as Ie,i as qe,g as l,s,r as q,A as ze,h as r,f as n,c as a,j as ye,u as z,x as h,k as _e,y as Ee,a as i,v as E,d as S,t as O,w as j,m as Ce,n as Me}from"../chunks/index.7f38e934.js";import{T as Ae}from"../chunks/Tip.ae532637.js";import{H as Le}from"../chunks/Heading.333929c4.js";import{E as Se}from"../chunks/EditOnGithub.c3245a01.js";function Oe(R){let o;return{c(){o=Ce("In this section, we dive into the inner workings of an AI agent—its ability to reason and plan. We’ll explore how the agent leverages its internal dialogue to analyze information, break down complex problems into manageable steps, and decide what action to take next. Additionally, we introduce the Re-Act approach, a prompting technique that encourages the model to think “step by step” before acting.")},l(p){o=Me(p,"In this section, we dive into the inner workings of an AI agent—its ability to reason and plan. We’ll explore how the agent leverages its internal dialogue to analyze information, break down complex problems into manageable steps, and decide what action to take next. Additionally, we introduce the Re-Act approach, a prompting technique that encourages the model to think “step by step” before acting.")},m(p,c){i(p,o,c)},d(p){p&&n(o)}}}function je(R){let o,p,c="These models have been trained to always include specific <em>thinking</em> sections (enclosed between <code>&lt;think&gt;</code> and <code>&lt;/think&gt;</code> special tokens). This is not just a prompting technique like ReAct, but a training method where the model learns to generate these sections after analyzing thousands of examples that show what we expect it to do.";return{c(){o=Ce(`We have recently seen a lot of interest for reasoning strategies. This is what's behind models like Deepseek R1 or OpenAI's o1, which have been fine-tuned to "think before answering".
`),p=l("p"),p.innerHTML=c},l(d){o=Me(d,`We have recently seen a lot of interest for reasoning strategies. This is what's behind models like Deepseek R1 or OpenAI's o1, which have been fine-tuned to "think before answering".
`),p=r(d,"P",{"data-svelte-h":!0}),h(p)!=="svelte-a1470c"&&(p.innerHTML=c)},m(d,m){i(d,o,m),i(d,p,m)},p:Re,d(d){d&&(n(o),n(p))}}}function Ge(R){let o,p,c,d,m,G,f,W,g,re="Thoughts represent the <strong>Agent’s internal reasoning and planning processes</strong> to solve the task.",B,b,pe="This utilises the agent’s Large Language Model (LLM) capacity <strong>to analyze information when presented in its prompt</strong>.",D,w,he="Think of it as the agent’s internal dialogue, where it considers the task at hand and strategizes its approach.",U,$,de="The Agent’s thoughts are responsible for accessing current observations and decide what the next action(s) should be.",N,x,ce="Through this process, the agent can <strong>break down complex problems into smaller, more manageable steps</strong>, reflect on past experiences, and continuously adjust its plans based on new information.",F,v,me="Here are some examples of common thoughts:",K,T,fe="<thead><tr><th>Type of Thought</th> <th>Example</th></tr></thead> <tbody><tr><td>Planning</td> <td>“I need to break this task into three steps: 1) gather data, 2) analyze trends, 3) generate report”</td></tr> <tr><td>Analysis</td> <td>“Based on the error message, the issue appears to be with the database connection parameters”</td></tr> <tr><td>Decision Making</td> <td>“Given the user’s budget constraints, I should recommend the mid-tier option”</td></tr> <tr><td>Problem Solving</td> <td>“To optimize this code, I should first profile it to identify bottlenecks”</td></tr> <tr><td>Memory Integration</td> <td>“The user mentioned their preference for Python earlier, so I’ll provide examples in Python”</td></tr> <tr><td>Self-Reflection</td> <td>“My last approach didn’t work well, I should try a different strategy”</td></tr> <tr><td>Goal Setting</td> <td>“To complete this task, I need to first establish the acceptance criteria”</td></tr> <tr><td>Prioritization</td> <td>“The security vulnerability should be addressed before adding new features”</td></tr></tbody>",Q,k,ue=`<p><strong>Note:</strong> In the case of LLMs fine-tuned for function-calling, the thought process is optional.
<em>In case you’re not familiar with function-calling, there will be more details in the Actions section.</em></p>`,J,y,V,_,ge="A key method is the <strong>ReAct approach</strong>, which is the concatenation of  “Reasoning” (Think) with “Acting” (Act).",X,A,be="ReAct is a simple prompting technique that appends “Let’s think step by step” before letting the LLM decode the next tokens.",Y,L,we="Indeed, prompting the model to think “step by step” encourages the decoding process toward next tokens <strong>that generate a plan</strong>, rather than a final solution, since the model is encouraged to <strong>decompose</strong> the problem into <em>sub-tasks</em>.",Z,C,$e="This allows the model to consider sub-steps in more detail, which in general leads to less errors than trying to generate the final solution directly.",ee,M,xe='<img src="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/ReAct.png" alt="ReAct"/> <figcaption>The (d) is an example of Re-Act approach where we prompt &quot;Let&#39;s think step by step&quot;</figcaption>',te,u,ne,ie,se,P,ve="Now that we better understand the Thought process, let’s go deeper on the second part of the process: Act.",ae,H,oe,I,le;return m=new Le({props:{title:"Thought: Internal Reasoning and the Re-Act Approach",local:"thought-internal-reasoning-and-the-re-act-approach",headingTag:"h1"}}),f=new Ae({props:{$$slots:{default:[Oe]},$$scope:{ctx:R}}}),y=new Le({props:{title:"The Re-Act Approach",local:"the-re-act-approach",headingTag:"h2"}}),u=new Ae({props:{$$slots:{default:[je]},$$scope:{ctx:R}}}),H=new Se({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/en/unit1/thoughts.mdx"}}),{c(){o=l("meta"),p=s(),c=l("p"),d=s(),q(m.$$.fragment),G=s(),q(f.$$.fragment),W=s(),g=l("p"),g.innerHTML=re,B=s(),b=l("p"),b.innerHTML=pe,D=s(),w=l("p"),w.textContent=he,U=s(),$=l("p"),$.textContent=de,N=s(),x=l("p"),x.innerHTML=ce,F=s(),v=l("p"),v.textContent=me,K=s(),T=l("table"),T.innerHTML=fe,Q=s(),k=l("blockquote"),k.innerHTML=ue,J=s(),q(y.$$.fragment),V=s(),_=l("p"),_.innerHTML=ge,X=s(),A=l("p"),A.textContent=be,Y=s(),L=l("p"),L.innerHTML=we,Z=s(),C=l("p"),C.textContent=$e,ee=s(),M=l("figure"),M.innerHTML=xe,te=s(),q(u.$$.fragment),ne=s(),ie=l("hr"),se=s(),P=l("p"),P.textContent=ve,ae=s(),q(H.$$.fragment),oe=s(),I=l("p"),this.h()},l(e){const t=ze("svelte-u9bgzb",document.head);o=r(t,"META",{name:!0,content:!0}),t.forEach(n),p=a(e),c=r(e,"P",{}),ye(c).forEach(n),d=a(e),z(m.$$.fragment,e),G=a(e),z(f.$$.fragment,e),W=a(e),g=r(e,"P",{"data-svelte-h":!0}),h(g)!=="svelte-1l9soxr"&&(g.innerHTML=re),B=a(e),b=r(e,"P",{"data-svelte-h":!0}),h(b)!=="svelte-1f7vu7v"&&(b.innerHTML=pe),D=a(e),w=r(e,"P",{"data-svelte-h":!0}),h(w)!=="svelte-qzqdp1"&&(w.textContent=he),U=a(e),$=r(e,"P",{"data-svelte-h":!0}),h($)!=="svelte-1k69e4y"&&($.textContent=de),N=a(e),x=r(e,"P",{"data-svelte-h":!0}),h(x)!=="svelte-1ngchwc"&&(x.innerHTML=ce),F=a(e),v=r(e,"P",{"data-svelte-h":!0}),h(v)!=="svelte-ompwrf"&&(v.textContent=me),K=a(e),T=r(e,"TABLE",{"data-svelte-h":!0}),h(T)!=="svelte-1efoj4x"&&(T.innerHTML=fe),Q=a(e),k=r(e,"BLOCKQUOTE",{"data-svelte-h":!0}),h(k)!=="svelte-lbm2tt"&&(k.innerHTML=ue),J=a(e),z(y.$$.fragment,e),V=a(e),_=r(e,"P",{"data-svelte-h":!0}),h(_)!=="svelte-xbnpor"&&(_.innerHTML=ge),X=a(e),A=r(e,"P",{"data-svelte-h":!0}),h(A)!=="svelte-3stkhz"&&(A.textContent=be),Y=a(e),L=r(e,"P",{"data-svelte-h":!0}),h(L)!=="svelte-1f470gx"&&(L.innerHTML=we),Z=a(e),C=r(e,"P",{"data-svelte-h":!0}),h(C)!=="svelte-cc5rnv"&&(C.textContent=$e),ee=a(e),M=r(e,"FIGURE",{"data-svelte-h":!0}),h(M)!=="svelte-d946n2"&&(M.innerHTML=xe),te=a(e),z(u.$$.fragment,e),ne=a(e),ie=r(e,"HR",{}),se=a(e),P=r(e,"P",{"data-svelte-h":!0}),h(P)!=="svelte-4r07cc"&&(P.textContent=ve),ae=a(e),z(H.$$.fragment,e),oe=a(e),I=r(e,"P",{}),ye(I).forEach(n),this.h()},h(){_e(o,"name","hf:doc:metadata"),_e(o,"content",We)},m(e,t){Ee(document.head,o),i(e,p,t),i(e,c,t),i(e,d,t),E(m,e,t),i(e,G,t),E(f,e,t),i(e,W,t),i(e,g,t),i(e,B,t),i(e,b,t),i(e,D,t),i(e,w,t),i(e,U,t),i(e,$,t),i(e,N,t),i(e,x,t),i(e,F,t),i(e,v,t),i(e,K,t),i(e,T,t),i(e,Q,t),i(e,k,t),i(e,J,t),E(y,e,t),i(e,V,t),i(e,_,t),i(e,X,t),i(e,A,t),i(e,Y,t),i(e,L,t),i(e,Z,t),i(e,C,t),i(e,ee,t),i(e,M,t),i(e,te,t),E(u,e,t),i(e,ne,t),i(e,ie,t),i(e,se,t),i(e,P,t),i(e,ae,t),E(H,e,t),i(e,oe,t),i(e,I,t),le=!0},p(e,[t]){const Te={};t&2&&(Te.$$scope={dirty:t,ctx:e}),f.$set(Te);const ke={};t&2&&(ke.$$scope={dirty:t,ctx:e}),u.$set(ke)},i(e){le||(S(m.$$.fragment,e),S(f.$$.fragment,e),S(y.$$.fragment,e),S(u.$$.fragment,e),S(H.$$.fragment,e),le=!0)},o(e){O(m.$$.fragment,e),O(f.$$.fragment,e),O(y.$$.fragment,e),O(u.$$.fragment,e),O(H.$$.fragment,e),le=!1},d(e){e&&(n(p),n(c),n(d),n(G),n(W),n(g),n(B),n(b),n(D),n(w),n(U),n($),n(N),n(x),n(F),n(v),n(K),n(T),n(Q),n(k),n(J),n(V),n(_),n(X),n(A),n(Y),n(L),n(Z),n(C),n(ee),n(M),n(te),n(ne),n(ie),n(se),n(P),n(ae),n(oe),n(I)),n(o),j(m,e),j(f,e),j(y,e),j(u,e),j(H,e)}}}const We='{"title":"Thought: Internal Reasoning and the Re-Act Approach","local":"thought-internal-reasoning-and-the-re-act-approach","sections":[{"title":"The Re-Act Approach","local":"the-re-act-approach","sections":[],"depth":2}],"depth":1}';function Be(R){return He(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Qe extends Ie{constructor(o){super(),qe(this,o,Be,Ge,Pe,{})}}export{Qe as component};
