import{s as ln,f as d,n as nn,o as sn}from"../chunks/scheduler.f6b352c8.js";import{S as an,i as on,g as a,s as i,r as u,A as rn,h as o,f as l,c as s,j as en,u as h,x as r,k as p,y as pn,a as n,v as f,d as m,t as c,w as g}from"../chunks/index.7f38e934.js";import{C as un}from"../chunks/CodeBlock.2a338b68.js";import{H as x}from"../chunks/Heading.333929c4.js";import{E as hn}from"../chunks/EditOnGithub.c3245a01.js";function fn(De){let v,qt,kt,Jt,C,Ut,w,Ke,Et,T,tl="In the previous sections, we learned:",Nt,A,el="<li><strong>How tools are made available to the agent in the system prompt</strong>.</li> <li><strong>How AI agents are systems that can ‘reason’, plan, and interact with their environment</strong>.</li>",Ot,M,ll="In this section, <strong>we’ll explore the complete AI Agent Workflow</strong>, a cycle we defined as Thought-Action-Observation.",Yt,$,nl="And then, we’ll dive deeper on each of these steps.",Gt,_,Wt,b,il="Agents work in a continuous cycle of: <strong>thinking (Thought) → acting (Act) and observing (Observe)</strong>.",zt,y,sl="Let’s break down these actions together:",Ft,L,al="<li><strong>Thought</strong>: The LLM part of the Agent decides what the next step should be.</li> <li><strong>Action:</strong> The agent takes an action, by calling the tools with the associated arguments.</li> <li><strong>Observation:</strong> The model reflects on the response from the tool.</li>",Rt,j,Bt,I,ol="The three components work together in a continuous loop. To use an analogy from programming, the agent uses a <strong>while loop</strong>: the loop continues until the objective of the agent has been fulfilled.",St,P,rl="Visually, it looks like this:",Qt,k,pl,Xt,H,ul="In many Agent frameworks, <strong>the rules and guidelines are embedded directly into the system prompt</strong>, ensuring that every cycle adheres to a defined logic.",Vt,q,hl="In a simplified version, our system prompt may look like this:",Zt,J,fl,Dt,U,ml="We see here that in the System Message we defined :",Kt,E,cl="<li>The <em>Agent’s behavior</em>.</li> <li>The <em>Tools our Agent has access to</em>, as we described in the previous section.</li> <li>The <em>Thought-Action-Observation Cycle</em>, that we bake into the LLM instructions.</li>",te,N,gl="Let’s take a small example to understand the process before going deeper into each step of the process.",ee,O,le,Y,vl="We created Alfred, the Weather Agent.",ne,G,dl="A user asks Alfred: “What’s the weather like in New York today?”",ie,W,xl,se,z,Cl="Alfred’s job is to answer this query using a weather API tool.",ae,F,wl="Here’s how the cycle unfolds:",oe,R,re,B,Tl="<strong>Internal Reasoning:</strong>",pe,S,Al="Upon receiving the query, Alfred’s internal dialogue might be:",ue,Q,Ml="<em>“The user needs current weather information for New York. I have access to a tool that fetches weather data. First, I need to call the weather API to get up-to-date details.”</em>",he,X,$l="This step shows the agent breaking the problem into steps: first, gathering the necessary data.",fe,V,_l,me,Z,ce,D,bl="<strong>Tool Usage:</strong>",ge,K,yl="Based on its reasoning and the fact that Alfred knows about a <code>get_weather</code> tool, Alfred prepares a JSON-formatted command that calls the weather API tool. For example, its first action could be:",ve,tt,Ll="Thought: I need to check the current weather for New York.",de,et,xe,lt,jl="Here, the action clearly specifies which tool to call (e.g., get_weather) and what parameter to pass (the “location”: “New York”).",Ce,nt,Il,we,it,Te,st,Pl="<strong>Feedback from the Environment:</strong>",Ae,at,kl="After the tool call, Alfred receives an observation. This might be the raw weather data from the API such as:",Me,ot,Hl="<em>“Current weather in New York: partly cloudy, 15°C, 60% humidity.”</em>",$e,rt,ql,_e,pt,Jl="This observation is then added to the prompt as additional context. It functions as real-world feedback, confirming whether the action succeeded and providing the needed details.",be,ut,ye,ht,Ul="<strong>Reflecting:</strong>",Le,ft,El="With the observation in hand, Alfred updates its internal reasoning:",je,mt,Nl="<em>“Now that I have the weather data for New York, I can compile an answer for the user.”</em>",Ie,ct,Ol,Pe,gt,ke,vt,Yl="Alfred then generates a final response formatted as we told it to:",He,dt,Gl="Thought: I have the weather data now. The current weather in New York is partly cloudy with a temperature of 15°C and 60% humidity.”",qe,xt,Wl="Final answer : The current weather in New York is partly cloudy with a temperature of 15°C and 60% humidity.",Je,Ct,zl="This final action sends the answer back to the user, closing the loop.",Ue,wt,Fl,Ee,Tt,Rl="What we see in this example:",Ne,At,Bl="<li><strong>Agents iterate through a loop until the objective is fullfilled:</strong></li>",Oe,Mt,Sl="<strong>Alfred’s process is cyclical</strong>. It starts with a thought, then acts by calling a tool, and finally observes the outcome. If the observation had indicated an error or incomplete data, Alfred could have re-entered the cycle to correct its approach.",Ye,$t,Ql="<li><strong>Tool Integration:</strong></li>",Ge,_t,Xl="The ability to call a tool (like a weather API) enables Alfred to go <strong>beyond static knowledge and retrieve real-time data</strong>, an essential aspect of many AI Agents.",We,bt,Vl="<li><strong>Dynamic Adaptation:</strong></li>",ze,yt,Zl="Each cycle allows the agent to incorporate fresh information (observations) into its reasoning (thought), ensuring that the final answer is well-informed and accurate.",Fe,Lt,Dl="This example showcases the core concept behind the <em>ReAct cycle</em> (a concept we’re going to develop in the next section): <strong>the interplay of Thought, Action, and Observation empowers AI agents to solve complex tasks iteratively</strong>.",Re,jt,Kl="By understanding and applying these principles, you can design agents that not only reason about their tasks but also <strong>effectively utilize external tools to complete them</strong>, all while continuously refining their output based on environmental feedback.",Be,Se,Qe,It,tn="Let’s now dive deeper into the Thought, Action, Observation as the individual steps of the process.",Xe,Pt,Ve,Ht,Ze;return C=new x({props:{title:"Understanding AI Agents through the Thought-Action-Observation Cycle",local:"understanding-ai-agents-through-the-thought-action-observation-cycle",headingTag:"h1"}}),_=new x({props:{title:"The Core Components",local:"the-core-components",headingTag:"h2"}}),j=new x({props:{title:"The Thought-Action-Observation Cycle",local:"the-thought-action-observation-cycle",headingTag:"h2"}}),O=new x({props:{title:"Alfred, the weather Agent",local:"alfred-the-weather-agent",headingTag:"h2"}}),R=new x({props:{title:"Thought",local:"thought",headingTag:"h3"}}),Z=new x({props:{title:"Action",local:"action",headingTag:"h3"}}),et=new un({props:{code:"JTIwJTIwJTIwJTdCJTBBJTIwJTIwJTIwJTIwJTIwJTIyYWN0aW9uJTIyJTNBJTIwJTIyZ2V0X3dlYXRoZXIlMjIlMkMlMEElMjAlMjAlMjAlMjAlMjAlMjJhY3Rpb25faW5wdXQlMjIlM0ElMjAlN0IlMEElMjAlMjAlMjAlMjAlMjAlMjAlMjAlMjJsb2NhdGlvbiUyMiUzQSUyMCUyMk5ldyUyMFlvcmslMjIlMEElMjAlMjAlMjAlMjAlMjAlN0QlMEElMjAlMjAlMjAlN0Q=",highlighted:`   <span class="hljs-punctuation">{</span>
     <span class="hljs-attr">&quot;action&quot;</span><span class="hljs-punctuation">:</span> <span class="hljs-string">&quot;get_weather&quot;</span><span class="hljs-punctuation">,</span>
     <span class="hljs-attr">&quot;action_input&quot;</span><span class="hljs-punctuation">:</span> <span class="hljs-punctuation">{</span>
       <span class="hljs-attr">&quot;location&quot;</span><span class="hljs-punctuation">:</span> <span class="hljs-string">&quot;New York&quot;</span>
     <span class="hljs-punctuation">}</span>
   <span class="hljs-punctuation">}</span>`,wrap:!1}}),it=new x({props:{title:"Observation",local:"observation",headingTag:"h3"}}),ut=new x({props:{title:"Updated thought",local:"updated-thought",headingTag:"h3"}}),gt=new x({props:{title:"Final Action",local:"final-action",headingTag:"h3"}}),Pt=new hn({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/en/unit1/agent-steps-and-structure.mdx"}}),{c(){v=a("meta"),qt=i(),kt=a("p"),Jt=i(),u(C.$$.fragment),Ut=i(),w=a("img"),Et=i(),T=a("p"),T.textContent=tl,Nt=i(),A=a("ul"),A.innerHTML=el,Ot=i(),M=a("p"),M.innerHTML=ll,Yt=i(),$=a("p"),$.textContent=nl,Gt=i(),u(_.$$.fragment),Wt=i(),b=a("p"),b.innerHTML=il,zt=i(),y=a("p"),y.textContent=sl,Ft=i(),L=a("ol"),L.innerHTML=al,Rt=i(),u(j.$$.fragment),Bt=i(),I=a("p"),I.innerHTML=ol,St=i(),P=a("p"),P.textContent=rl,Qt=i(),k=a("img"),Xt=i(),H=a("p"),H.innerHTML=ul,Vt=i(),q=a("p"),q.textContent=hl,Zt=i(),J=a("img"),Dt=i(),U=a("p"),U.textContent=ml,Kt=i(),E=a("ul"),E.innerHTML=cl,te=i(),N=a("p"),N.textContent=gl,ee=i(),u(O.$$.fragment),le=i(),Y=a("p"),Y.textContent=vl,ne=i(),G=a("p"),G.textContent=dl,ie=i(),W=a("img"),se=i(),z=a("p"),z.textContent=Cl,ae=i(),F=a("p"),F.textContent=wl,oe=i(),u(R.$$.fragment),re=i(),B=a("p"),B.innerHTML=Tl,pe=i(),S=a("p"),S.textContent=Al,ue=i(),Q=a("p"),Q.innerHTML=Ml,he=i(),X=a("p"),X.textContent=$l,fe=i(),V=a("img"),me=i(),u(Z.$$.fragment),ce=i(),D=a("p"),D.innerHTML=bl,ge=i(),K=a("p"),K.innerHTML=yl,ve=i(),tt=a("p"),tt.textContent=Ll,de=i(),u(et.$$.fragment),xe=i(),lt=a("p"),lt.textContent=jl,Ce=i(),nt=a("img"),we=i(),u(it.$$.fragment),Te=i(),st=a("p"),st.innerHTML=Pl,Ae=i(),at=a("p"),at.textContent=kl,Me=i(),ot=a("p"),ot.innerHTML=Hl,$e=i(),rt=a("img"),_e=i(),pt=a("p"),pt.textContent=Jl,be=i(),u(ut.$$.fragment),ye=i(),ht=a("p"),ht.innerHTML=Ul,Le=i(),ft=a("p"),ft.textContent=El,je=i(),mt=a("p"),mt.innerHTML=Nl,Ie=i(),ct=a("img"),Pe=i(),u(gt.$$.fragment),ke=i(),vt=a("p"),vt.textContent=Yl,He=i(),dt=a("p"),dt.textContent=Gl,qe=i(),xt=a("p"),xt.textContent=Wl,Je=i(),Ct=a("p"),Ct.textContent=zl,Ue=i(),wt=a("img"),Ee=i(),Tt=a("p"),Tt.textContent=Rl,Ne=i(),At=a("ul"),At.innerHTML=Bl,Oe=i(),Mt=a("p"),Mt.innerHTML=Sl,Ye=i(),$t=a("ul"),$t.innerHTML=Ql,Ge=i(),_t=a("p"),_t.innerHTML=Xl,We=i(),bt=a("ul"),bt.innerHTML=Vl,ze=i(),yt=a("p"),yt.textContent=Zl,Fe=i(),Lt=a("p"),Lt.innerHTML=Dl,Re=i(),jt=a("p"),jt.innerHTML=Kl,Be=i(),Se=a("hr"),Qe=i(),It=a("p"),It.textContent=tn,Xe=i(),u(Pt.$$.fragment),Ve=i(),Ht=a("p"),this.h()},l(t){const e=rn("svelte-u9bgzb",document.head);v=o(e,"META",{name:!0,content:!0}),e.forEach(l),qt=s(t),kt=o(t,"P",{}),en(kt).forEach(l),Jt=s(t),h(C.$$.fragment,t),Ut=s(t),w=o(t,"IMG",{src:!0,alt:!0}),Et=s(t),T=o(t,"P",{"data-svelte-h":!0}),r(T)!=="svelte-7llfj6"&&(T.textContent=tl),Nt=s(t),A=o(t,"UL",{"data-svelte-h":!0}),r(A)!=="svelte-3e83i0"&&(A.innerHTML=el),Ot=s(t),M=o(t,"P",{"data-svelte-h":!0}),r(M)!=="svelte-1dokcbw"&&(M.innerHTML=ll),Yt=s(t),$=o(t,"P",{"data-svelte-h":!0}),r($)!=="svelte-14c74an"&&($.textContent=nl),Gt=s(t),h(_.$$.fragment,t),Wt=s(t),b=o(t,"P",{"data-svelte-h":!0}),r(b)!=="svelte-1o7nh6s"&&(b.innerHTML=il),zt=s(t),y=o(t,"P",{"data-svelte-h":!0}),r(y)!=="svelte-optv5e"&&(y.textContent=sl),Ft=s(t),L=o(t,"OL",{"data-svelte-h":!0}),r(L)!=="svelte-1h7ub85"&&(L.innerHTML=al),Rt=s(t),h(j.$$.fragment,t),Bt=s(t),I=o(t,"P",{"data-svelte-h":!0}),r(I)!=="svelte-1qe4h0s"&&(I.innerHTML=ol),St=s(t),P=o(t,"P",{"data-svelte-h":!0}),r(P)!=="svelte-s2kplf"&&(P.textContent=rl),Qt=s(t),k=o(t,"IMG",{src:!0,alt:!0}),Xt=s(t),H=o(t,"P",{"data-svelte-h":!0}),r(H)!=="svelte-i9knc1"&&(H.innerHTML=ul),Vt=s(t),q=o(t,"P",{"data-svelte-h":!0}),r(q)!=="svelte-140ldms"&&(q.textContent=hl),Zt=s(t),J=o(t,"IMG",{src:!0,alt:!0}),Dt=s(t),U=o(t,"P",{"data-svelte-h":!0}),r(U)!=="svelte-e5pmx1"&&(U.textContent=ml),Kt=s(t),E=o(t,"UL",{"data-svelte-h":!0}),r(E)!=="svelte-1a0b0ns"&&(E.innerHTML=cl),te=s(t),N=o(t,"P",{"data-svelte-h":!0}),r(N)!=="svelte-1tsmln9"&&(N.textContent=gl),ee=s(t),h(O.$$.fragment,t),le=s(t),Y=o(t,"P",{"data-svelte-h":!0}),r(Y)!=="svelte-1232lbo"&&(Y.textContent=vl),ne=s(t),G=o(t,"P",{"data-svelte-h":!0}),r(G)!=="svelte-1gw1vpx"&&(G.textContent=dl),ie=s(t),W=o(t,"IMG",{src:!0,alt:!0}),se=s(t),z=o(t,"P",{"data-svelte-h":!0}),r(z)!=="svelte-1yedpwx"&&(z.textContent=Cl),ae=s(t),F=o(t,"P",{"data-svelte-h":!0}),r(F)!=="svelte-82uzmq"&&(F.textContent=wl),oe=s(t),h(R.$$.fragment,t),re=s(t),B=o(t,"P",{"data-svelte-h":!0}),r(B)!=="svelte-bbakro"&&(B.innerHTML=Tl),pe=s(t),S=o(t,"P",{"data-svelte-h":!0}),r(S)!=="svelte-x8n7iu"&&(S.textContent=Al),ue=s(t),Q=o(t,"P",{"data-svelte-h":!0}),r(Q)!=="svelte-1rwco72"&&(Q.innerHTML=Ml),he=s(t),X=o(t,"P",{"data-svelte-h":!0}),r(X)!=="svelte-nh852z"&&(X.textContent=$l),fe=s(t),V=o(t,"IMG",{src:!0,alt:!0}),me=s(t),h(Z.$$.fragment,t),ce=s(t),D=o(t,"P",{"data-svelte-h":!0}),r(D)!=="svelte-15s12fo"&&(D.innerHTML=bl),ge=s(t),K=o(t,"P",{"data-svelte-h":!0}),r(K)!=="svelte-5pokbk"&&(K.innerHTML=yl),ve=s(t),tt=o(t,"P",{"data-svelte-h":!0}),r(tt)!=="svelte-rqzrlx"&&(tt.textContent=Ll),de=s(t),h(et.$$.fragment,t),xe=s(t),lt=o(t,"P",{"data-svelte-h":!0}),r(lt)!=="svelte-u780jw"&&(lt.textContent=jl),Ce=s(t),nt=o(t,"IMG",{src:!0,alt:!0}),we=s(t),h(it.$$.fragment,t),Te=s(t),st=o(t,"P",{"data-svelte-h":!0}),r(st)!=="svelte-xv12jk"&&(st.innerHTML=Pl),Ae=s(t),at=o(t,"P",{"data-svelte-h":!0}),r(at)!=="svelte-f8am0x"&&(at.textContent=kl),Me=s(t),ot=o(t,"P",{"data-svelte-h":!0}),r(ot)!=="svelte-17ah7xm"&&(ot.innerHTML=Hl),$e=s(t),rt=o(t,"IMG",{src:!0,alt:!0}),_e=s(t),pt=o(t,"P",{"data-svelte-h":!0}),r(pt)!=="svelte-1qtefyv"&&(pt.textContent=Jl),be=s(t),h(ut.$$.fragment,t),ye=s(t),ht=o(t,"P",{"data-svelte-h":!0}),r(ht)!=="svelte-thyb76"&&(ht.innerHTML=Ul),Le=s(t),ft=o(t,"P",{"data-svelte-h":!0}),r(ft)!=="svelte-12w4wqc"&&(ft.textContent=El),je=s(t),mt=o(t,"P",{"data-svelte-h":!0}),r(mt)!=="svelte-26gu5r"&&(mt.innerHTML=Nl),Ie=s(t),ct=o(t,"IMG",{src:!0,alt:!0}),Pe=s(t),h(gt.$$.fragment,t),ke=s(t),vt=o(t,"P",{"data-svelte-h":!0}),r(vt)!=="svelte-1ce6r84"&&(vt.textContent=Yl),He=s(t),dt=o(t,"P",{"data-svelte-h":!0}),r(dt)!=="svelte-oe9jao"&&(dt.textContent=Gl),qe=s(t),xt=o(t,"P",{"data-svelte-h":!0}),r(xt)!=="svelte-1pdvdow"&&(xt.textContent=Wl),Je=s(t),Ct=o(t,"P",{"data-svelte-h":!0}),r(Ct)!=="svelte-1o695ae"&&(Ct.textContent=zl),Ue=s(t),wt=o(t,"IMG",{src:!0,alt:!0}),Ee=s(t),Tt=o(t,"P",{"data-svelte-h":!0}),r(Tt)!=="svelte-beg0lg"&&(Tt.textContent=Rl),Ne=s(t),At=o(t,"UL",{"data-svelte-h":!0}),r(At)!=="svelte-148fcxr"&&(At.innerHTML=Bl),Oe=s(t),Mt=o(t,"P",{"data-svelte-h":!0}),r(Mt)!=="svelte-iiv7bs"&&(Mt.innerHTML=Sl),Ye=s(t),$t=o(t,"UL",{"data-svelte-h":!0}),r($t)!=="svelte-ibv0wc"&&($t.innerHTML=Ql),Ge=s(t),_t=o(t,"P",{"data-svelte-h":!0}),r(_t)!=="svelte-9n1qd1"&&(_t.innerHTML=Xl),We=s(t),bt=o(t,"UL",{"data-svelte-h":!0}),r(bt)!=="svelte-hbr0le"&&(bt.innerHTML=Vl),ze=s(t),yt=o(t,"P",{"data-svelte-h":!0}),r(yt)!=="svelte-1e08iqd"&&(yt.textContent=Zl),Fe=s(t),Lt=o(t,"P",{"data-svelte-h":!0}),r(Lt)!=="svelte-xccp62"&&(Lt.innerHTML=Dl),Re=s(t),jt=o(t,"P",{"data-svelte-h":!0}),r(jt)!=="svelte-2zcn5x"&&(jt.innerHTML=Kl),Be=s(t),Se=o(t,"HR",{}),Qe=s(t),It=o(t,"P",{"data-svelte-h":!0}),r(It)!=="svelte-7kcpcc"&&(It.textContent=tn),Xe=s(t),h(Pt.$$.fragment,t),Ve=s(t),Ht=o(t,"P",{}),en(Ht).forEach(l),this.h()},h(){p(v,"name","hf:doc:metadata"),p(v,"content",mn),d(w.src,Ke="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/whiteboard-check-3.jpg")||p(w,"src",Ke),p(w,"alt","Unit 1 planning"),d(k.src,pl="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/AgentCycle.gif")||p(k,"src",pl),p(k,"alt","Think, Act, Observe cycle"),d(J.src,fl="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/system_prompt_cycle.png")||p(J,"src",fl),p(J,"alt","Think, Act, Observe cycle"),d(W.src,xl="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/alfred-agent.jpg")||p(W,"src",xl),p(W,"alt","Alfred Agent"),d(V.src,_l="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/alfred-agent-1.jpg")||p(V,"src",_l),p(V,"alt","Alfred Agent"),d(nt.src,Il="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/alfred-agent-2.jpg")||p(nt,"src",Il),p(nt,"alt","Alfred Agent"),d(rt.src,ql="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/alfred-agent-3.jpg")||p(rt,"src",ql),p(rt,"alt","Alfred Agent"),d(ct.src,Ol="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/alfred-agent-4.jpg")||p(ct,"src",Ol),p(ct,"alt","Alfred Agent"),d(wt.src,Fl="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/alfred-agent-5.jpg")||p(wt,"src",Fl),p(wt,"alt","Alfred Agent")},m(t,e){pn(document.head,v),n(t,qt,e),n(t,kt,e),n(t,Jt,e),f(C,t,e),n(t,Ut,e),n(t,w,e),n(t,Et,e),n(t,T,e),n(t,Nt,e),n(t,A,e),n(t,Ot,e),n(t,M,e),n(t,Yt,e),n(t,$,e),n(t,Gt,e),f(_,t,e),n(t,Wt,e),n(t,b,e),n(t,zt,e),n(t,y,e),n(t,Ft,e),n(t,L,e),n(t,Rt,e),f(j,t,e),n(t,Bt,e),n(t,I,e),n(t,St,e),n(t,P,e),n(t,Qt,e),n(t,k,e),n(t,Xt,e),n(t,H,e),n(t,Vt,e),n(t,q,e),n(t,Zt,e),n(t,J,e),n(t,Dt,e),n(t,U,e),n(t,Kt,e),n(t,E,e),n(t,te,e),n(t,N,e),n(t,ee,e),f(O,t,e),n(t,le,e),n(t,Y,e),n(t,ne,e),n(t,G,e),n(t,ie,e),n(t,W,e),n(t,se,e),n(t,z,e),n(t,ae,e),n(t,F,e),n(t,oe,e),f(R,t,e),n(t,re,e),n(t,B,e),n(t,pe,e),n(t,S,e),n(t,ue,e),n(t,Q,e),n(t,he,e),n(t,X,e),n(t,fe,e),n(t,V,e),n(t,me,e),f(Z,t,e),n(t,ce,e),n(t,D,e),n(t,ge,e),n(t,K,e),n(t,ve,e),n(t,tt,e),n(t,de,e),f(et,t,e),n(t,xe,e),n(t,lt,e),n(t,Ce,e),n(t,nt,e),n(t,we,e),f(it,t,e),n(t,Te,e),n(t,st,e),n(t,Ae,e),n(t,at,e),n(t,Me,e),n(t,ot,e),n(t,$e,e),n(t,rt,e),n(t,_e,e),n(t,pt,e),n(t,be,e),f(ut,t,e),n(t,ye,e),n(t,ht,e),n(t,Le,e),n(t,ft,e),n(t,je,e),n(t,mt,e),n(t,Ie,e),n(t,ct,e),n(t,Pe,e),f(gt,t,e),n(t,ke,e),n(t,vt,e),n(t,He,e),n(t,dt,e),n(t,qe,e),n(t,xt,e),n(t,Je,e),n(t,Ct,e),n(t,Ue,e),n(t,wt,e),n(t,Ee,e),n(t,Tt,e),n(t,Ne,e),n(t,At,e),n(t,Oe,e),n(t,Mt,e),n(t,Ye,e),n(t,$t,e),n(t,Ge,e),n(t,_t,e),n(t,We,e),n(t,bt,e),n(t,ze,e),n(t,yt,e),n(t,Fe,e),n(t,Lt,e),n(t,Re,e),n(t,jt,e),n(t,Be,e),n(t,Se,e),n(t,Qe,e),n(t,It,e),n(t,Xe,e),f(Pt,t,e),n(t,Ve,e),n(t,Ht,e),Ze=!0},p:nn,i(t){Ze||(m(C.$$.fragment,t),m(_.$$.fragment,t),m(j.$$.fragment,t),m(O.$$.fragment,t),m(R.$$.fragment,t),m(Z.$$.fragment,t),m(et.$$.fragment,t),m(it.$$.fragment,t),m(ut.$$.fragment,t),m(gt.$$.fragment,t),m(Pt.$$.fragment,t),Ze=!0)},o(t){c(C.$$.fragment,t),c(_.$$.fragment,t),c(j.$$.fragment,t),c(O.$$.fragment,t),c(R.$$.fragment,t),c(Z.$$.fragment,t),c(et.$$.fragment,t),c(it.$$.fragment,t),c(ut.$$.fragment,t),c(gt.$$.fragment,t),c(Pt.$$.fragment,t),Ze=!1},d(t){t&&(l(qt),l(kt),l(Jt),l(Ut),l(w),l(Et),l(T),l(Nt),l(A),l(Ot),l(M),l(Yt),l($),l(Gt),l(Wt),l(b),l(zt),l(y),l(Ft),l(L),l(Rt),l(Bt),l(I),l(St),l(P),l(Qt),l(k),l(Xt),l(H),l(Vt),l(q),l(Zt),l(J),l(Dt),l(U),l(Kt),l(E),l(te),l(N),l(ee),l(le),l(Y),l(ne),l(G),l(ie),l(W),l(se),l(z),l(ae),l(F),l(oe),l(re),l(B),l(pe),l(S),l(ue),l(Q),l(he),l(X),l(fe),l(V),l(me),l(ce),l(D),l(ge),l(K),l(ve),l(tt),l(de),l(xe),l(lt),l(Ce),l(nt),l(we),l(Te),l(st),l(Ae),l(at),l(Me),l(ot),l($e),l(rt),l(_e),l(pt),l(be),l(ye),l(ht),l(Le),l(ft),l(je),l(mt),l(Ie),l(ct),l(Pe),l(ke),l(vt),l(He),l(dt),l(qe),l(xt),l(Je),l(Ct),l(Ue),l(wt),l(Ee),l(Tt),l(Ne),l(At),l(Oe),l(Mt),l(Ye),l($t),l(Ge),l(_t),l(We),l(bt),l(ze),l(yt),l(Fe),l(Lt),l(Re),l(jt),l(Be),l(Se),l(Qe),l(It),l(Xe),l(Ve),l(Ht)),l(v),g(C,t),g(_,t),g(j,t),g(O,t),g(R,t),g(Z,t),g(et,t),g(it,t),g(ut,t),g(gt,t),g(Pt,t)}}}const mn='{"title":"Understanding AI Agents through the Thought-Action-Observation Cycle","local":"understanding-ai-agents-through-the-thought-action-observation-cycle","sections":[{"title":"The Core Components","local":"the-core-components","sections":[],"depth":2},{"title":"The Thought-Action-Observation Cycle","local":"the-thought-action-observation-cycle","sections":[],"depth":2},{"title":"Alfred, the weather Agent","local":"alfred-the-weather-agent","sections":[{"title":"Thought","local":"thought","sections":[],"depth":3},{"title":"Action","local":"action","sections":[],"depth":3},{"title":"Observation","local":"observation","sections":[],"depth":3},{"title":"Updated thought","local":"updated-thought","sections":[],"depth":3},{"title":"Final Action","local":"final-action","sections":[],"depth":3}],"depth":2}],"depth":1}';function cn(De){return sn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class wn extends an{constructor(v){super(),on(this,v,cn,fn,ln,{})}}export{wn as component};
